<!DOCTYPE html>
<html>

<head>
  <title>List users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <!-- Import awesome-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">


</head>

<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>User List</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Filter</button>
        </div>
      </div>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead class="thead-dark">
        <tr>
          <th scope='col'>No.</th>
          <th scope='col'>Username</th>
          <th scope='col'>First name</th>
          <th scope='col'>Last name</th>
          <th scope='col'>Email</th>
          <th scope='col'>Age</th>
          <th scope='col'>Role</th>
          <th scope='col'>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>

  <!-- Modal Voucher History -->
  <div class="row p-3">
    <div id="modal-voucher-history" class="modal fade" tabindex="-1">
      <div class="modal-dialog modal-xl">
        <div class="modal-content">
          <div class="modal-header">
            <h4>VOUCHER HISTORY</h4>
            <a role="button" class="close" data-dismiss="modal">&times;</a>
          </div>
          <div class="modal-body bg-light">
            <div class="row">
              <div class="col-sm-12">
                <p><b>Player Information</b></p>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-1">
                <label class="col-form-label">Username:</label>
              </div>
              <div class="col-sm-3">
                <input id="inp-voucher-username" class="form-control" placeholder="Username...">
              </div>
              <div class="col-sm-1">
                <label class="col-form-label">Firstname:</label>
              </div>
              <div class="col-sm-3">
                <input id="inp-voucher-firstname" class="form-control" placeholder="Firstname...">
              </div>
              <div class="col-sm-1">
                <label class="col-form-label">Lastname:</label>
              </div>
              <div class="col-sm-3">
                <input id="inp-voucher-lastname" class="form-control" placeholder="Lastname...">
              </div>
            </div>
            <div class="row">
              <div class="col-sm-12">
                <table id="table-voucher-history" class="table table-light table-bordered table-striped table-hover">
                  <thead>
                    <tr>
                      <th>STT</th>
                      <th>Voucher Code</th>
                      <th>Discount</th>
                      <th>Create Date</th>
                    </tr>
                  </thead>
                  <tbody>

                  </tbody>
                </table>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" data-dismiss="modal">Back</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13
    }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin"
    },
    {
      roleId: 8,
      roleName: "Manager"
    },
    {
      roleId: 11,
      roleName: "Teacher"
    },
    {
      roleId: 13,
      roleName: "Staff"
    }
  ];

  var gNameCol = [
    "stt",
    "username",
    "firstname",
    "lastname",
    "email",
    "age",
    "roleId",
    "action"
  ];

  const gSTT_COL = 0;
  const gUSER_NAME_COL = 1;
  const gFIRST_NAME_COL = 2;
  const gLAST_NAME_COL = 3;
  const gEMAIL_COL = 4;
  const gAGE_COL = 5;
  const gROLE_COL = 6;
  const gACTION_COL = 7;
  var gUsername = "";
  var gFirstname = "";
  var gLastname = "";


  var gPlayerTable = $("#user-table").DataTable({
    //data: gUserObjects,
    columns: [
      { data: gNameCol[gSTT_COL] },
      { data: gNameCol[gUSER_NAME_COL] },
      { data: gNameCol[gFIRST_NAME_COL] },
      { data: gNameCol[gLAST_NAME_COL] },
      { data: gNameCol[gEMAIL_COL] },
      { data: gNameCol[gAGE_COL] },
      { data: gNameCol[gROLE_COL] },
      { data: gNameCol[gACTION_COL] }
    ], // Các thuộc tính của USER sẽ  match với từng column
    columnDefs: [
      //định nghĩa các cột cần hiện ra
      {
        targets: gSTT_COL, //cột STT
        className: "text-center text-primary",
        render: function (data, type, row, meta) {
          return meta.row + meta.settings._iDisplayStart + 1;
        }
      },
      {
        targets: gROLE_COL,
        className: "text-right",
        render: mappingRoleNameByID
      },
      {
        targets: gACTION_COL, //cột Action
        className: "text-center",
        defaultContent: `
            <button id= "dice-history"  <i title = 'Dice History' class="fas fa-dice text-success" style = "cursor:pointer;"></i></button> &nbsp; 
            <button id= "voucher-history" <i title = 'Voucher History' class="fas fa-gift text-success" style = "cursor:pointer;"></i></button>`,
      }
    ]
  });

  var gUser = {
    username: "",
    firstname: "",
    lastname: ""
  };

  const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

  // DATA TABLE OF VOUCHER HISTORY
  var gVoucherSTT = 1;
  const gVOUCHER_TABLE_ROW = ["id", "maVoucher", "phanTramGiamGia", "ngayTao"];
  const gVOUCHER_STT_COL = 0;
  const gVOUCHER_CODE_COL = 1;
  const gVOUCHER_DISCOUNT = 2;
  const gVOUCHER_DAY_CREATE_COL = 3;
  var gVoucherTable = $("#table-voucher-history").DataTable({
    columns: [
      { data: gVOUCHER_TABLE_ROW[gVOUCHER_STT_COL] },
      { data: gVOUCHER_TABLE_ROW[gVOUCHER_CODE_COL] },
      { data: gVOUCHER_TABLE_ROW[gVOUCHER_DISCOUNT] },
      { data: gVOUCHER_TABLE_ROW[gVOUCHER_DAY_CREATE_COL] },
    ],
    columnDefs: [
      {
        targets: gVOUCHER_STT_COL,
        render: function () {
          return gVoucherSTT++;
        }
      }
    ]
  })


  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
  });

  //thêm sự kiện cho nút filter
  $("#btn-filter-role").on("click", function () {
    onBtnFilterRoleClick();
  })

  //gán sự kiện cho nút dice history
  $("#user-table").on("click", "#dice-history", function () {
    onBtnDiceHistoryClick(this);
  });

  //gán sự kiện cho nút voucher history
  $("#user-table").on("click", "#voucher-history", function () {
    onBtnVoucherHistoryClick(this);
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    loadDataToRoleSelect();
    showTableUserDataTable(gUserObjects);
    $('[data-toggle="tooltip"]').tooltip();
  }


  function loadDataToRoleSelect() {
    var vRoleSelect = $("#roleSelect");
    $("<option/>", {
      text: "--- Chọn tất cả ---",
      value: 0
    }).appendTo(vRoleSelect);

    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      var bRoleTypeOption = $("<option/>", {
        text: gRoleObjects[bI].roleName,
        value: gRoleObjects[bI].roleId
      }).appendTo(vRoleSelect);
    }
  }

  function showTableUserDataTable(paramUserObj) {
    console.log(paramUserObj);
    gPlayerTable.rows.add(paramUserObj);
    gPlayerTable.draw();

  }


  //hàm xử lý sự kiện filter
  function onBtnFilterRoleClick() {
    //khai báo đối tượng chứa dữ liệu filter
    var vFilterRoleId = {
      roleId: 0
    };
    //B1 thu thập dữ liệu để filter
    getFilterFormData(vFilterRoleId);
    //B2: validate (k cần)
    //B3: xử lý filter
    filterRoles(vFilterRoleId);
  }


  //hàm gọi ra khi nhấn nút dice history
  function onBtnDiceHistoryClick(paramBtnEdit) {
    // B1: Thu thập dữ liệu
    getUserData(paramBtnEdit);
    // B2: Kiểm tra dữ liệu
    var gUsername = gUser.username;
    var gFirstname = gUser.firstname;
    var gLastname = gUser.lastname;

    /*cách khác hơi dài
    // lưu thông tin đang được nhấn nút vào biến toàn cục
    var gUsername = getUsernameFromButton(paramBtnEdit);
    var gFirstname = getFirstnameFromButton(paramBtnEdit);
    var gLastname = getLastnameFromButton(paramBtnEdit);
    console.log("username: " + gUsername + " firstname: " + gFirstname + " lastname: " + gLastname)*/


    //xử lý chuyển trang
    const vDETAIL_FORM_URL = "DiceHistory.html"
    var vUrlSiteToOpen = vDETAIL_FORM_URL +
      "?user_name" + "=" + gUsername +
      "&first_name" + "=" + gFirstname +
      "&last_name" + "=" + gLastname;
    location.href = vUrlSiteToOpen;

  }

  //hàm get User data
  function getUserData(paramBtn) {
    var vTableRow = $(paramBtn).parents("tr");
    var vRowData = gPlayerTable.row(vTableRow).data();
    gUser.username = vRowData.username;
    gUser.firstname = vRowData.firstname;
    gUser.lastname = vRowData.lastname;
    return gUser;
  };

  /*
  //  hàm dựa vào button dice history xác định đc username
  function getUsernameFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vVoucherRowData = gPlayerTable.row(vTableRow).data();
    return vVoucherRowData.username;
  }

  //  hàm dựa vào button dice history xác định đc firstname
  function getFirstnameFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vVoucherRowData = gPlayerTable.row(vTableRow).data();
    return vVoucherRowData.firstname;
  }
  //  hàm dựa vào button dice history xác định đc lastname
  function getLastnameFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vVoucherRowData = gPlayerTable.row(vTableRow).data();
    return vVoucherRowData.lastname;
  } */


  // function xử lý sự kiện click button Voucher History
  function onBtnVoucherHistoryClick(paramBtnVoucherHistory) {
    $("#modal-voucher-history").modal("show");
    // B1: Thu thập dữ liệu
    gUser = getUserData(paramBtnVoucherHistory);
    // B2: Kiểm tra dữ liệu
    // B3: Gọi API lấy lịch sử voucher
    apiGetVoucherHistory();
    showVoucherDataToModal();

  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function mappingRoleNameByID(paramData, paramType, paramRow) {
    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      const bRoleObjItem = gRoleObjects[bI];
      if (paramData == bRoleObjItem.roleId) {
        return bRoleObjItem.roleName;
      }
    }
  }


  //hàm thực hiện lọc và hiển thị lên table
  function filterRoles(paramFilterObj) {
    var vRolesResult = [];
    //thực hiện lọc
    vRolesResult = gUserObjects.filter(function (paramFilter) {
      return (paramFilterObj.roleId == 0 || paramFilter.roleId == paramFilterObj.roleId);
    });
    console.log(vRolesResult);
    //load dữ liệu filter lên table
    loadRolesToTable(vRolesResult);
  }

  //hàm thu thập dữ liệu để lọc
  function getFilterFormData(paramFilterObj) {
    paramFilterObj.roleId = $("#roleSelect").val();
    console.log("roleId đã lọc là: " + paramFilterObj.roleId);
  }

  //hàm load dữ liệu vào user table
  function loadRolesToTable(paramUserArr) {
    $('#user-table').DataTable().clear();
    $('#user-table').DataTable().rows.add(paramUserArr);
    $('#user-table').DataTable().draw();

  }

  // hàm get voucher by username
  function apiGetVoucherHistory() {
    $.ajax({
      url: gBASE_URL + "/voucher-history?username=" + gUser.username,
      type: "GET",
      success: function (paramVoucher) {
        console.log(paramVoucher);
        displayVoucherHistoryTable(paramVoucher);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      }
    });
    // hiển thị modal lên
    $("#modal-voucher-history").modal("show");
  }

  function showVoucherDataToModal() {
    $("#inp-voucher-username").val(gUser.username);
    $("#inp-voucher-firstname").val(gUser.firstname);
    $("#inp-voucher-lastname").val(gUser.lastname);
  }

  // function hiển thị table Voucher History
  function displayVoucherHistoryTable(paramVoucherHistory) {
    gVoucherSTT = 1;
    var vVoucherData = paramVoucherHistory.vouchers;
    gVoucherTable.clear();
    gVoucherTable.rows.add(vVoucherData);
    gVoucherTable.draw();
  }




</script>

</html>